using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data.OleDb;  // database 

namespace Gster
{
	public class BookingForm : System.Windows.Forms.Form

	{
		private OleDbConnection con;  // database
		private OleDbCommand cmd;	  // database 	
		private int antaldage;

		private string bookdato, dd1, mm1, aa1;	
		int d1, m1, a1, d2, m2, a2;
		private DateTime dato1, dato2, dato3;

		private System.Windows.Forms.Label lblFradato;
		private System.Windows.Forms.Label lblTildato;
		private System.Windows.Forms.TextBox txtFradato;
		private System.Windows.Forms.TextBox txtTildato;
		private System.Windows.Forms.Label lblVrelsestype;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Button btnVis;
		private System.Windows.Forms.Button btnOpretGst;
		private System.Windows.Forms.Label lblVrelse;
		private System.Windows.Forms.TextBox txtVrelse;
		private System.Windows.Forms.Label lblGst;
		private System.Windows.Forms.TextBox txtGstnr;
		private System.Windows.Forms.Button btnBeregnPris;
		private System.Windows.Forms.TextBox txtPris;
		private System.Windows.Forms.Button btnBook;
		private System.Windows.Forms.RadioButton btnBegge1;
		private System.Windows.Forms.RadioButton btnBegge2;
		private System.Windows.Forms.RadioButton btnBegge3;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.RadioButton btnDobbelt;
		private System.Windows.Forms.RadioButton btnEnkelt;
		private System.Windows.Forms.RadioButton btnIkkeRyger;
		private System.Windows.Forms.RadioButton btnRyger;
		private System.Windows.Forms.RadioButton btnEjHandicap;
		private System.Windows.Forms.RadioButton btnHandicap;
		private System.Windows.Forms.Button btnRediger;
		private System.ComponentModel.Container components = null;

		public BookingForm()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lblFradato = new System.Windows.Forms.Label();
			this.lblTildato = new System.Windows.Forms.Label();
			this.txtFradato = new System.Windows.Forms.TextBox();
			this.txtTildato = new System.Windows.Forms.TextBox();
			this.lblVrelsestype = new System.Windows.Forms.Label();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.btnBegge1 = new System.Windows.Forms.RadioButton();
			this.btnDobbelt = new System.Windows.Forms.RadioButton();
			this.btnEnkelt = new System.Windows.Forms.RadioButton();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.btnBegge2 = new System.Windows.Forms.RadioButton();
			this.btnIkkeRyger = new System.Windows.Forms.RadioButton();
			this.btnRyger = new System.Windows.Forms.RadioButton();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.btnBegge3 = new System.Windows.Forms.RadioButton();
			this.btnEjHandicap = new System.Windows.Forms.RadioButton();
			this.btnHandicap = new System.Windows.Forms.RadioButton();
			this.btnVis = new System.Windows.Forms.Button();
			this.btnOpretGst = new System.Windows.Forms.Button();
			this.lblVrelse = new System.Windows.Forms.Label();
			this.txtVrelse = new System.Windows.Forms.TextBox();
			this.lblGst = new System.Windows.Forms.Label();
			this.txtGstnr = new System.Windows.Forms.TextBox();
			this.btnBeregnPris = new System.Windows.Forms.Button();
			this.txtPris = new System.Windows.Forms.TextBox();
			this.btnBook = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.btnRediger = new System.Windows.Forms.Button();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.SuspendLayout();
			// 
			// lblFradato
			// 
			this.lblFradato.Location = new System.Drawing.Point(24, 24);
			this.lblFradato.Name = "lblFradato";
			this.lblFradato.TabIndex = 0;
			this.lblFradato.Text = "Indtast Fra-Dato:";
			// 
			// lblTildato
			// 
			this.lblTildato.Location = new System.Drawing.Point(24, 64);
			this.lblTildato.Name = "lblTildato";
			this.lblTildato.TabIndex = 1;
			this.lblTildato.Text = "Indtast Til-Dato:";
			// 
			// txtFradato
			// 
			this.txtFradato.Location = new System.Drawing.Point(144, 24);
			this.txtFradato.Name = "txtFradato";
			this.txtFradato.TabIndex = 2;
			this.txtFradato.Text = "";
			// 
			// txtTildato
			// 
			this.txtTildato.Location = new System.Drawing.Point(144, 56);
			this.txtTildato.Name = "txtTildato";
			this.txtTildato.TabIndex = 3;
			this.txtTildato.Text = "";
			// 
			// lblVrelsestype
			// 
			this.lblVrelsestype.Location = new System.Drawing.Point(24, 96);
			this.lblVrelsestype.Name = "lblVrelsestype";
			this.lblVrelsestype.Size = new System.Drawing.Size(80, 23);
			this.lblVrelsestype.TabIndex = 4;
			this.lblVrelsestype.Text = "VrelsesType:";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.btnBegge1);
			this.groupBox1.Controls.Add(this.btnDobbelt);
			this.groupBox1.Controls.Add(this.btnEnkelt);
			this.groupBox1.Location = new System.Drawing.Point(96, 96);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(120, 120);
			this.groupBox1.TabIndex = 5;
			this.groupBox1.TabStop = false;
			// 
			// btnBegge1
			// 
			this.btnBegge1.Checked = true;
			this.btnBegge1.Location = new System.Drawing.Point(8, 88);
			this.btnBegge1.Name = "btnBegge1";
			this.btnBegge1.TabIndex = 2;
			this.btnBegge1.TabStop = true;
			this.btnBegge1.Text = "Begge";
			// 
			// btnDobbelt
			// 
			this.btnDobbelt.Location = new System.Drawing.Point(8, 56);
			this.btnDobbelt.Name = "btnDobbelt";
			this.btnDobbelt.TabIndex = 1;
			this.btnDobbelt.Text = "Dobbelt";
			// 
			// btnEnkelt
			// 
			this.btnEnkelt.Location = new System.Drawing.Point(8, 16);
			this.btnEnkelt.Name = "btnEnkelt";
			this.btnEnkelt.TabIndex = 0;
			this.btnEnkelt.Text = "Enkelt";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.btnBegge2);
			this.groupBox2.Controls.Add(this.btnIkkeRyger);
			this.groupBox2.Controls.Add(this.btnRyger);
			this.groupBox2.Location = new System.Drawing.Point(224, 96);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(120, 120);
			this.groupBox2.TabIndex = 6;
			this.groupBox2.TabStop = false;
			// 
			// btnBegge2
			// 
			this.btnBegge2.Checked = true;
			this.btnBegge2.Location = new System.Drawing.Point(8, 88);
			this.btnBegge2.Name = "btnBegge2";
			this.btnBegge2.TabIndex = 2;
			this.btnBegge2.TabStop = true;
			this.btnBegge2.Text = "Begge";
			// 
			// btnIkkeRyger
			// 
			this.btnIkkeRyger.Location = new System.Drawing.Point(8, 56);
			this.btnIkkeRyger.Name = "btnIkkeRyger";
			this.btnIkkeRyger.TabIndex = 1;
			this.btnIkkeRyger.Text = "Ikke-ryger";
			// 
			// btnRyger
			// 
			this.btnRyger.Location = new System.Drawing.Point(8, 16);
			this.btnRyger.Name = "btnRyger";
			this.btnRyger.TabIndex = 0;
			this.btnRyger.Text = "Ryger";
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.Add(this.btnBegge3);
			this.groupBox3.Controls.Add(this.btnEjHandicap);
			this.groupBox3.Controls.Add(this.btnHandicap);
			this.groupBox3.Location = new System.Drawing.Point(360, 96);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(144, 120);
			this.groupBox3.TabIndex = 7;
			this.groupBox3.TabStop = false;
			// 
			// btnBegge3
			// 
			this.btnBegge3.Checked = true;
			this.btnBegge3.Location = new System.Drawing.Point(8, 88);
			this.btnBegge3.Name = "btnBegge3";
			this.btnBegge3.TabIndex = 2;
			this.btnBegge3.TabStop = true;
			this.btnBegge3.Text = "Begge ";
			// 
			// btnEjHandicap
			// 
			this.btnEjHandicap.Location = new System.Drawing.Point(8, 56);
			this.btnEjHandicap.Name = "btnEjHandicap";
			this.btnEjHandicap.Size = new System.Drawing.Size(120, 24);
			this.btnEjHandicap.TabIndex = 1;
			this.btnEjHandicap.Text = "Ej handicap-venlig";
			// 
			// btnHandicap
			// 
			this.btnHandicap.Location = new System.Drawing.Point(8, 16);
			this.btnHandicap.Name = "btnHandicap";
			this.btnHandicap.TabIndex = 0;
			this.btnHandicap.Text = "Handicap-venlig";
			// 
			// btnVis
			// 
			this.btnVis.Location = new System.Drawing.Point(24, 240);
			this.btnVis.Name = "btnVis";
			this.btnVis.Size = new System.Drawing.Size(120, 23);
			this.btnVis.TabIndex = 8;
			this.btnVis.Text = "Vis ledige vrelser";
			this.btnVis.Click += new System.EventHandler(this.btnVis_Click);
			// 
			// btnOpretGst
			// 
			this.btnOpretGst.Location = new System.Drawing.Point(152, 240);
			this.btnOpretGst.Name = "btnOpretGst";
			this.btnOpretGst.Size = new System.Drawing.Size(112, 23);
			this.btnOpretGst.TabIndex = 9;
			this.btnOpretGst.Text = "Opret/Vis Gst";
			this.btnOpretGst.Click += new System.EventHandler(this.btnOpretGst_Click);
			// 
			// lblVrelse
			// 
			this.lblVrelse.Location = new System.Drawing.Point(32, 304);
			this.lblVrelse.Name = "lblVrelse";
			this.lblVrelse.Size = new System.Drawing.Size(104, 23);
			this.lblVrelse.TabIndex = 10;
			this.lblVrelse.Text = "Indtast Vrelsesnr:";
			// 
			// txtVrelse
			// 
			this.txtVrelse.Location = new System.Drawing.Point(152, 304);
			this.txtVrelse.Name = "txtVrelse";
			this.txtVrelse.TabIndex = 11;
			this.txtVrelse.Text = "";
			// 
			// lblGst
			// 
			this.lblGst.Location = new System.Drawing.Point(32, 280);
			this.lblGst.Name = "lblGst";
			this.lblGst.Size = new System.Drawing.Size(96, 23);
			this.lblGst.TabIndex = 12;
			this.lblGst.Text = "Indtast Gstnr:";
			// 
			// txtGstnr
			// 
			this.txtGstnr.Location = new System.Drawing.Point(152, 280);
			this.txtGstnr.Name = "txtGstnr";
			this.txtGstnr.TabIndex = 13;
			this.txtGstnr.Text = "";
			// 
			// btnBeregnPris
			// 
			this.btnBeregnPris.Location = new System.Drawing.Point(280, 240);
			this.btnBeregnPris.Name = "btnBeregnPris";
			this.btnBeregnPris.Size = new System.Drawing.Size(104, 23);
			this.btnBeregnPris.TabIndex = 14;
			this.btnBeregnPris.Text = "Beregn pris";
			this.btnBeregnPris.Visible = false;
			// 
			// txtPris
			// 
			this.txtPris.Location = new System.Drawing.Point(392, 240);
			this.txtPris.Name = "txtPris";
			this.txtPris.Size = new System.Drawing.Size(104, 20);
			this.txtPris.TabIndex = 15;
			this.txtPris.Text = "";
			this.txtPris.Visible = false;
			// 
			// btnBook
			// 
			this.btnBook.Location = new System.Drawing.Point(280, 304);
			this.btnBook.Name = "btnBook";
			this.btnBook.Size = new System.Drawing.Size(112, 23);
			this.btnBook.TabIndex = 16;
			this.btnBook.Text = "Book vrelse";
			this.btnBook.Click += new System.EventHandler(this.btnBook_Click);
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(312, 24);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(120, 20);
			this.textBox1.TabIndex = 17;
			this.textBox1.Text = "";
			this.textBox1.Visible = false;
			// 
			// btnRediger
			// 
			this.btnRediger.Location = new System.Drawing.Point(408, 304);
			this.btnRediger.Name = "btnRediger";
			this.btnRediger.Size = new System.Drawing.Size(104, 23);
			this.btnRediger.TabIndex = 18;
			this.btnRediger.Text = "Rediger ";
			// 
			// BookingForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(528, 350);
			this.Controls.Add(this.btnRediger);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.txtPris);
			this.Controls.Add(this.txtGstnr);
			this.Controls.Add(this.txtVrelse);
			this.Controls.Add(this.txtTildato);
			this.Controls.Add(this.txtFradato);
			this.Controls.Add(this.btnBook);
			this.Controls.Add(this.btnBeregnPris);
			this.Controls.Add(this.lblGst);
			this.Controls.Add(this.lblVrelse);
			this.Controls.Add(this.btnOpretGst);
			this.Controls.Add(this.btnVis);
			this.Controls.Add(this.groupBox3);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.lblVrelsestype);
			this.Controls.Add(this.lblTildato);
			this.Controls.Add(this.lblFradato);
			this.Name = "BookingForm";
			this.Text = "Booking af hotelvrelse";
			this.Load += new System.EventHandler(this.BookingForm_Load);
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void btnOpretGst_Click(object sender, System.EventArgs e)
		{
			GstForm f1 = new GstForm();
			f1.ShowDialog(this);

		}

		private bool erSkudr(int r)
		{
			if (r % 4 != 0)
				return false;
			else if (r % 100 == 0 && r % 400 != 0)
				return false;
			else
				return true;
		}

		private int dageIMned(int mned, int r)
		{
			switch(mned)
			{
				case 4:
				case 6:
				case 9:
				case 11: return 30;
				case 2:
					if (erSkudr(r))
						return 29;
					else
						return 28;
				default: return 31;
			}
		}

		public void NsteDato(int dag, int mned, int r)
		{
			if (++dag > dageIMned(mned, r))
			{
				++mned;
				dag = 1;
			}
			if (mned > 12)
			{
				++r;
				mned = 1;
			}
		}
		private void BeregnAntalDage()
		{
			//int d1, m1, a1, d2, m2, a2;
			int dagnr1, dagnr2;

			d1 = Convert.ToInt32(txtFradato.Text.Substring(0,2));
			m1 = Convert.ToInt32(txtFradato.Text.Substring(3,2));
			a1 = Convert.ToInt32(txtFradato.Text.Substring(6,2));
			dato1 = new DateTime(a1,m1,d1);

			d2 = Convert.ToInt32(txtTildato.Text.Substring(0,2));
			m2 = Convert.ToInt32(txtTildato.Text.Substring(3,2));
			a2 = Convert.ToInt32(txtTildato.Text.Substring(6,2));
			dato2 = new DateTime(a2,m2,d2);

			dagnr1 = dato1.DayOfYear;
			dagnr2 = dato2.DayOfYear;
			
			if (dagnr1 > dagnr2)
			{
				if (erSkudr(a1)) 
					antaldage = (366 - dagnr1) + dagnr2 + 1;
				else
					antaldage = (365 - dagnr1) + dagnr2 + 1;
			}
			else
				antaldage = dagnr2 - dagnr1 + 1;
		
		}

		private void BookingForm_Load(object sender, System.EventArgs e)
		{
			string connectionStr;
			connectionStr= "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=Hotelbooking.mdb";

			con= new OleDbConnection(connectionStr);
			cmd= new OleDbCommand();
			cmd.Connection=con; 
		
		}

		
		private void btnBook_Click(object sender, System.EventArgs e)
		{
			cmd.CommandText="INSERT INTO Booking(GstID,FraDato,TilDato) VALUES(@GstID,@FraDato,@TilDato)";
			cmd.Parameters.Clear();
			cmd.Parameters.Add("@GstID",OleDbType.Integer).Value = Convert.ToInt32(txtGstnr.Text);
			cmd.Parameters.Add("@FraDato",OleDbType.VarChar).Value = txtFradato.Text;
			cmd.Parameters.Add("@TilDato",OleDbType.VarChar).Value = txtTildato.Text;
			
			con.Open();
			cmd.ExecuteNonQuery();
			con.Close();

			BeregnAntalDage();
			

			{
				OleDbDataReader datareader1;

				cmd.CommandText = "SELECT BookingID FROM Booking WHERE Booking.GstID = "+Convert.ToInt32(txtGstnr.Text)+" AND Booking.FraDato ='" + txtFradato.Text+"'";

				con.Open();   // ben forbindelsen til databasen
				datareader1 = cmd.ExecuteReader();

				textBox1.Text = "";

				if (datareader1.Read() == true)
				{
					textBox1.Text = Convert.ToString(datareader1["BookingID"]);
				}
				con.Close();
			}
			
			bookdato = txtFradato.Text;
 
			for (int i=0; i < antaldage; i++)
			{
				if (i != 0)
				{
					d1 = Convert.ToInt32(bookdato.Substring(0,2));
					m1 = Convert.ToInt32(bookdato.Substring(3,2));
					a1 = Convert.ToInt32(bookdato.Substring(6,2));
					
					if (++d1 > dageIMned(m1, a1))
					{
					{
						++m1;
						d1 = 1;
					}
						if (m1 > 12)
						{
							++a1;
							m1 = 1;
						}
					}
					
					if (d1 < 10)
					
						dd1 = "0" + Convert.ToString(d1);
					else
						dd1 = Convert.ToString(d1);
					
					if (m1 < 10)
											
						mm1 = "0" + Convert.ToString(m1);
					else
						mm1 = Convert.ToString(m1);
					

					if (a1 < 10)
					
						aa1 = "0" + Convert.ToString(a1);
					else
						aa1 = Convert.ToString(a1);
					
					bookdato = dd1 + "-" + mm1 + "-" + aa1;

					//bookdato = Convert.ToString(d1) + "-" + Convert.ToString(m1) + "-" + Convert.ToString(a1);
				}

				cmd.Parameters.Clear();
				
				cmd.CommandText="INSERT INTO BookingDag(Vrelsesnr,Dato,BookingID) VALUES(@Vrelsesnr,@Dato,@BookingID)";
				cmd.Parameters.Add("@Vrelsesnr",OleDbType.Integer).Value = Convert.ToInt32(txtVrelse.Text);
				cmd.Parameters.Add("@Dato",OleDbType.VarChar).Value = bookdato;
				cmd.Parameters.Add("@BookingID",OleDbType.Integer).Value = Convert.ToInt32(textBox1.Text);
			
				con.Open();
				cmd.ExecuteNonQuery();
				con.Close();

			}

		}

		private void btnVis_Click(object sender, System.EventArgs e)
		{
			VisLedigVrelseForm f = new VisLedigVrelseForm ();
			f.ShowDialog(this);
		}
		
	}			
}

		

		
		

		
	

